#ifndef ZASM_PP_MACRO_H
#define ZASM_PP_MACRO_H 1

#define PP_MACRO_T(O) ((struct pp_macro_t *)(O))
struct pp_macro_t
{
  // public
  struct list_t *args;
  struct list_t *body;
};

#include <zasm/alloc.h>
#define PP_MACRO_ALLOC_T(O) ((struct pp_macro_alloc_t *)(O))
ALLOC_DECLARE(pp_macro, ALLOC_DEF_COUNT);

#include <zasm/list.h>
#include <zasm/pp_namespace.h>
struct pp_macro_t *pp_macro_new(struct pp_level_t *level, struct list_t *args, struct list_t *body);
void pp_macro_fill(struct pp_macro_t *macro, struct list_t *args, struct list_t *body);
void pp_macro_delete(struct pp_macro_t *macro);
void pp_macro_free(struct pp_macro_t *macro);

#endif
